## Scripting improvements

The scripting system has been reworked in order to make it more intuitive and powerful.

The script execution types have been renamed, the documentation has been improved, and a new execution type has been added. The new runnable execution type will allow you to call a script from the connection hub directly in a dropdown for each connection when the script is active. This will also replace the current terminal command functionality, which has been removed.

Any file browser scripts are now grouped by the scripts groups they are in, improving the overview when having many file browser scripts. Furthermore, you can now launch these scripts in the file browser either in the background if they are quiet or in a terminal if they are intended to be interactive. When multiple files are selected, a script is now called only once with all the selected files as arguments.

## More terminal support

There is now support to use the following terminals:
- Termius
- MobaXterm
- Xshell
- SecureCRT

These work via a local SSH bridge that is managed by XPipe.

## Teleport support

There is now support to add your teleport connections that are available via tsh. You can do that by searching for available connections on any system which has tsh installed.

## Workspaces

You can now create multiple user workspaces in the settings menu. This will create desktop shortcuts that you can use to start XPipe with different workspaces active.

## Serial connection support

There is now support to add serial connections. Note that this feature is untested due to me not having physical serial devices around. If you have some, it would be very helpful if you could quickly try out the serial support and share your feedback.

## TTYs and PTYs

Up until now, if you added a connection that always allocated pty, XPipe would complain about a missing stderr. This was usually the case with badly implemented third-party ssh wrappers. In XPipe 11, there has been a ground up rework of the shell initialization code which will in theory allow for better handling of these cases. You can therefore now also launch such connections from the hub in a terminal. More advanced operations, such as the file browser, are not it possible for these connections though.

## Other

- Fix git sync freezing when using key with passphrase on modern ssh clients
- Fix git sync restarting daemon after exit when using key with passphrase
- Fix git vault readme not being generated on first push when no connections were added
- Fix terminal exit not working properly in fish
- Fix renaming a connection clearing all state information
- Fix script enabled status being wrong after editing an enabled script
- Fix download move operation failing when moving a directory that already existed in the downloads folder
- Fix some scrollbars are necessarily showing
- External git vault data files are now also encrypted by default
- Rework state information display for proxmox VMs
- Automatically fill identity file for ssh config wildcard keys as well
- Improve error messages when system interaction was disabled for a system
- Don't show git all compatibility warnings on minor version updates
- Enable ZGC on Linux and macOS
- Some small appearance fixes
